/* tslint:disable */
/* eslint-disable */
/**
* @param {Graph} graph
* @returns {any}
*/
export function initialPlacement(graph: Graph): any;
/**
* @param {Graph} graph
* @returns {Array<any>}
*/
export function forceConnected(graph: Graph): Array<any>;
/**
* @param {Graph} graph
* @returns {Array<any>}
*/
export function forceNonconnected(graph: Graph): Array<any>;
/**
* @param {Graph} graph
* @param {Function} group_accessor
* @returns {Array<any>}
*/
export function forceGrouped(graph: Graph, group_accessor: Function): Array<any>;
/**
* @param {Graph} graph
* @param {any} coordinates
* @param {Function} _length
* @param {number} eps
* @param {number} width
* @param {number} height
* @returns {any}
*/
export function kamadaKawai(graph: Graph, coordinates: any, _length: Function, eps: number, width: number, height: number): any;
/**
* @param {Graph} graph
* @param {number} min_size
* @param {number} step_iteration
* @param {Function} _shrink_node
* @param {Function} _shrink_edge
* @param {Function} _link_distance_accessor
* @returns {any}
*/
export function fm3(graph: Graph, min_size: number, step_iteration: number, _shrink_node: Function, _shrink_edge: Function, _link_distance_accessor: Function): any;
/**
* @param {Graph} graph
* @param {any} coordinates
* @returns {any}
*/
export function fdeb(graph: Graph, coordinates: any): any;
/**
*/
export class CenterForce {
  free(): void;
/**
*/
  constructor();
}
/**
*/
export class Force {
  free(): void;
}
/**
*/
export class Graph {
  free(): void;
/**
*/
  constructor();
/**
* @returns {number}
*/
  nodeCount(): number;
/**
* @returns {number}
*/
  edgeCount(): number;
/**
* @param {any} value
* @returns {number}
*/
  addNode(value: any): number;
/**
* @param {number} a
* @returns {any}
*/
  nodeWeight(a: number): any;
/**
* @param {number} a
* @param {number} b
* @param {any} value
* @returns {number}
*/
  addEdge(a: number, b: number, value: any): number;
/**
* @param {number} e
* @returns {any}
*/
  edgeWeight(e: number): any;
/**
* @param {number} e
* @returns {Array<any>}
*/
  edgeEndpoints(e: number): Array<any>;
/**
* @param {number} a
* @returns {any}
*/
  removeNode(a: number): any;
/**
* @param {number} e
* @returns {any}
*/
  removeEdge(e: number): any;
/**
* @param {number} a
* @returns {Array<any>}
*/
  neighbors(a: number): Array<any>;
/**
* @param {number} a
* @param {number} dir
* @returns {Array<any>}
*/
  neighborsDirected(a: number, dir: number): Array<any>;
/**
* @param {number} a
* @returns {Array<any>}
*/
  neighborsUndirected(a: number): Array<any>;
/**
* @param {number} a
* @returns {Array<any>}
*/
  edges(a: number): Array<any>;
/**
* @param {number} a
* @param {number} b
* @returns {boolean}
*/
  containsEdge(a: number, b: number): boolean;
/**
* @param {number} a
* @param {number} b
* @returns {number}
*/
  findEdge(a: number, b: number): number;
/**
* @param {number} dir
* @returns {Array<any>}
*/
  externals(dir: number): Array<any>;
/**
* @returns {Array<any>}
*/
  nodeIndices(): Array<any>;
/**
* @returns {Array<any>}
*/
  edgeIndices(): Array<any>;
}
/**
*/
export class LinkForce {
  free(): void;
/**
* @param {Graph} graph
*/
  constructor(graph: Graph);
}
/**
*/
export class ManyBodyForce {
  free(): void;
/**
* @param {Graph} graph
*/
  constructor(graph: Graph);
}
/**
*/
export class Simulation {
  free(): void;
/**
* @param {Graph} graph
* @param {Function} f
*/
  constructor(graph: Graph, f: Function);
/**
* @param {any[]} js_forces
* @returns {any}
*/
  run(js_forces: any[]): any;
/**
* @param {number} n
* @param {any[]} js_forces
* @returns {any}
*/
  runStep(n: number, js_forces: any[]): any;
/**
* @returns {boolean}
*/
  isFinished(): boolean;
/**
* @param {number} alpha_start
*/
  reset(alpha_start: number): void;
/**
* @returns {number}
*/
  alphaMin: number;
/**
* @returns {number}
*/
  alphaStart: number;
/**
* @returns {number}
*/
  alphaTarget: number;
/**
* @returns {number}
*/
  iterations: number;
/**
* @returns {number}
*/
  velocityDecay: number;
}
