let imports = {};
imports['__wbindgen_placeholder__'] = module.exports;
let wasm;
const { TextDecoder, TextEncoder } = require(String.raw`util`);

let cachedTextDecoder = new TextDecoder('utf-8', { ignoreBOM: true, fatal: true });

cachedTextDecoder.decode();

let cachegetUint8Memory0 = null;
function getUint8Memory0() {
    if (cachegetUint8Memory0 === null || cachegetUint8Memory0.buffer !== wasm.memory.buffer) {
        cachegetUint8Memory0 = new Uint8Array(wasm.memory.buffer);
    }
    return cachegetUint8Memory0;
}

function getStringFromWasm0(ptr, len) {
    return cachedTextDecoder.decode(getUint8Memory0().subarray(ptr, ptr + len));
}

const heap = new Array(32).fill(undefined);

heap.push(undefined, null, true, false);

let heap_next = heap.length;

function addHeapObject(obj) {
    if (heap_next === heap.length) heap.push(heap.length + 1);
    const idx = heap_next;
    heap_next = heap[idx];

    heap[idx] = obj;
    return idx;
}

function getObject(idx) { return heap[idx]; }

function dropObject(idx) {
    if (idx < 36) return;
    heap[idx] = heap_next;
    heap_next = idx;
}

function takeObject(idx) {
    const ret = getObject(idx);
    dropObject(idx);
    return ret;
}

let WASM_VECTOR_LEN = 0;

let cachedTextEncoder = new TextEncoder('utf-8');

const encodeString = (typeof cachedTextEncoder.encodeInto === 'function'
    ? function (arg, view) {
    return cachedTextEncoder.encodeInto(arg, view);
}
    : function (arg, view) {
    const buf = cachedTextEncoder.encode(arg);
    view.set(buf);
    return {
        read: arg.length,
        written: buf.length
    };
});

function passStringToWasm0(arg, malloc, realloc) {

    if (realloc === undefined) {
        const buf = cachedTextEncoder.encode(arg);
        const ptr = malloc(buf.length);
        getUint8Memory0().subarray(ptr, ptr + buf.length).set(buf);
        WASM_VECTOR_LEN = buf.length;
        return ptr;
    }

    let len = arg.length;
    let ptr = malloc(len);

    const mem = getUint8Memory0();

    let offset = 0;

    for (; offset < len; offset++) {
        const code = arg.charCodeAt(offset);
        if (code > 0x7F) break;
        mem[ptr + offset] = code;
    }

    if (offset !== len) {
        if (offset !== 0) {
            arg = arg.slice(offset);
        }
        ptr = realloc(ptr, len, len = offset + arg.length * 3);
        const view = getUint8Memory0().subarray(ptr + offset, ptr + len);
        const ret = encodeString(arg, view);

        offset += ret.written;
    }

    WASM_VECTOR_LEN = offset;
    return ptr;
}

let cachegetInt32Memory0 = null;
function getInt32Memory0() {
    if (cachegetInt32Memory0 === null || cachegetInt32Memory0.buffer !== wasm.memory.buffer) {
        cachegetInt32Memory0 = new Int32Array(wasm.memory.buffer);
    }
    return cachegetInt32Memory0;
}

function isLikeNone(x) {
    return x === undefined || x === null;
}

let cachegetFloat64Memory0 = null;
function getFloat64Memory0() {
    if (cachegetFloat64Memory0 === null || cachegetFloat64Memory0.buffer !== wasm.memory.buffer) {
        cachegetFloat64Memory0 = new Float64Array(wasm.memory.buffer);
    }
    return cachegetFloat64Memory0;
}

function debugString(val) {
    // primitive types
    const type = typeof val;
    if (type == 'number' || type == 'boolean' || val == null) {
        return  `${val}`;
    }
    if (type == 'string') {
        return `"${val}"`;
    }
    if (type == 'symbol') {
        const description = val.description;
        if (description == null) {
            return 'Symbol';
        } else {
            return `Symbol(${description})`;
        }
    }
    if (type == 'function') {
        const name = val.name;
        if (typeof name == 'string' && name.length > 0) {
            return `Function(${name})`;
        } else {
            return 'Function';
        }
    }
    // objects
    if (Array.isArray(val)) {
        const length = val.length;
        let debug = '[';
        if (length > 0) {
            debug += debugString(val[0]);
        }
        for(let i = 1; i < length; i++) {
            debug += ', ' + debugString(val[i]);
        }
        debug += ']';
        return debug;
    }
    // Test for built-in
    const builtInMatches = /\[object ([^\]]+)\]/.exec(toString.call(val));
    let className;
    if (builtInMatches.length > 1) {
        className = builtInMatches[1];
    } else {
        // Failed to match the standard '[object ClassName]'
        return toString.call(val);
    }
    if (className == 'Object') {
        // we're a user defined class or Object
        // JSON.stringify avoids problems with cycles, and is generally much
        // easier than looping through ownProperties of `val`.
        try {
            return 'Object(' + JSON.stringify(val) + ')';
        } catch (_) {
            return 'Object';
        }
    }
    // errors
    if (val instanceof Error) {
        return `${val.name}: ${val.message}\n${val.stack}`;
    }
    // TODO we could test for more things here, like `Set`s and `Map`s.
    return className;
}

function _assertClass(instance, klass) {
    if (!(instance instanceof klass)) {
        throw new Error(`expected instance of ${klass.name}`);
    }
    return instance.ptr;
}
/**
* @param {Graph} graph
* @returns {any}
*/
module.exports.initialPlacement = function(graph) {
    _assertClass(graph, Graph);
    var ret = wasm.initialPlacement(graph.ptr);
    return takeObject(ret);
};

/**
* @param {Graph} graph
* @returns {Array<any>}
*/
module.exports.forceConnected = function(graph) {
    _assertClass(graph, Graph);
    var ret = wasm.forceConnected(graph.ptr);
    return takeObject(ret);
};

/**
* @param {Graph} graph
* @returns {Array<any>}
*/
module.exports.forceNonconnected = function(graph) {
    _assertClass(graph, Graph);
    var ret = wasm.forceNonconnected(graph.ptr);
    return takeObject(ret);
};

let stack_pointer = 32;

function addBorrowedObject(obj) {
    if (stack_pointer == 1) throw new Error('out of js stack');
    heap[--stack_pointer] = obj;
    return stack_pointer;
}
/**
* @param {Graph} graph
* @param {Function} group_accessor
* @returns {Array<any>}
*/
module.exports.forceGrouped = function(graph, group_accessor) {
    try {
        _assertClass(graph, Graph);
        var ret = wasm.forceGrouped(graph.ptr, addBorrowedObject(group_accessor));
        return takeObject(ret);
    } finally {
        heap[stack_pointer++] = undefined;
    }
};

let cachegetUint32Memory0 = null;
function getUint32Memory0() {
    if (cachegetUint32Memory0 === null || cachegetUint32Memory0.buffer !== wasm.memory.buffer) {
        cachegetUint32Memory0 = new Uint32Array(wasm.memory.buffer);
    }
    return cachegetUint32Memory0;
}

function passArrayJsValueToWasm0(array, malloc) {
    const ptr = malloc(array.length * 4);
    const mem = getUint32Memory0();
    for (let i = 0; i < array.length; i++) {
        mem[ptr / 4 + i] = addHeapObject(array[i]);
    }
    WASM_VECTOR_LEN = array.length;
    return ptr;
}
/**
* @param {Graph} graph
* @param {any} coordinates
* @param {Function} _length
* @param {number} eps
* @param {number} width
* @param {number} height
* @returns {any}
*/
module.exports.kamadaKawai = function(graph, coordinates, _length, eps, width, height) {
    _assertClass(graph, Graph);
    var ret = wasm.kamadaKawai(graph.ptr, addHeapObject(coordinates), addHeapObject(_length), eps, width, height);
    return takeObject(ret);
};

/**
* @param {Graph} graph
* @param {number} min_size
* @param {number} step_iteration
* @param {Function} _shrink_node
* @param {Function} _shrink_edge
* @param {Function} _link_distance_accessor
* @returns {any}
*/
module.exports.fm3 = function(graph, min_size, step_iteration, _shrink_node, _shrink_edge, _link_distance_accessor) {
    _assertClass(graph, Graph);
    var ret = wasm.fm3(graph.ptr, min_size, step_iteration, addHeapObject(_shrink_node), addHeapObject(_shrink_edge), addHeapObject(_link_distance_accessor));
    return takeObject(ret);
};

/**
* @param {Graph} graph
* @param {any} coordinates
* @returns {any}
*/
module.exports.fdeb = function(graph, coordinates) {
    try {
        _assertClass(graph, Graph);
        var ret = wasm.fdeb(graph.ptr, addBorrowedObject(coordinates));
        return takeObject(ret);
    } finally {
        heap[stack_pointer++] = undefined;
    }
};

function handleError(f) {
    return function () {
        try {
            return f.apply(this, arguments);

        } catch (e) {
            wasm.__wbindgen_exn_store(addHeapObject(e));
        }
    };
}
/**
*/
class CenterForce {

    free() {
        const ptr = this.ptr;
        this.ptr = 0;

        wasm.__wbg_centerforce_free(ptr);
    }
    /**
    */
    constructor() {
        var ret = wasm.centerforce_new();
        return Force.__wrap(ret);
    }
}
module.exports.CenterForce = CenterForce;
/**
*/
class Force {

    static __wrap(ptr) {
        const obj = Object.create(Force.prototype);
        obj.ptr = ptr;

        return obj;
    }

    free() {
        const ptr = this.ptr;
        this.ptr = 0;

        wasm.__wbg_force_free(ptr);
    }
}
module.exports.Force = Force;
/**
*/
class Graph {

    static __wrap(ptr) {
        const obj = Object.create(Graph.prototype);
        obj.ptr = ptr;

        return obj;
    }

    free() {
        const ptr = this.ptr;
        this.ptr = 0;

        wasm.__wbg_graph_free(ptr);
    }
    /**
    */
    constructor() {
        var ret = wasm.graph_new();
        return Graph.__wrap(ret);
    }
    /**
    * @returns {number}
    */
    nodeCount() {
        var ret = wasm.graph_nodeCount(this.ptr);
        return ret >>> 0;
    }
    /**
    * @returns {number}
    */
    edgeCount() {
        var ret = wasm.graph_edgeCount(this.ptr);
        return ret >>> 0;
    }
    /**
    * @param {any} value
    * @returns {number}
    */
    addNode(value) {
        var ret = wasm.graph_addNode(this.ptr, addHeapObject(value));
        return ret >>> 0;
    }
    /**
    * @param {number} a
    * @returns {any}
    */
    nodeWeight(a) {
        var ret = wasm.graph_nodeWeight(this.ptr, a);
        return takeObject(ret);
    }
    /**
    * @param {number} a
    * @param {number} b
    * @param {any} value
    * @returns {number}
    */
    addEdge(a, b, value) {
        var ret = wasm.graph_addEdge(this.ptr, a, b, addHeapObject(value));
        return ret >>> 0;
    }
    /**
    * @param {number} e
    * @returns {any}
    */
    edgeWeight(e) {
        var ret = wasm.graph_edgeWeight(this.ptr, e);
        return takeObject(ret);
    }
    /**
    * @param {number} e
    * @returns {Array<any>}
    */
    edgeEndpoints(e) {
        var ret = wasm.graph_edgeEndpoints(this.ptr, e);
        return takeObject(ret);
    }
    /**
    * @param {number} a
    * @returns {any}
    */
    removeNode(a) {
        var ret = wasm.graph_removeNode(this.ptr, a);
        return takeObject(ret);
    }
    /**
    * @param {number} e
    * @returns {any}
    */
    removeEdge(e) {
        var ret = wasm.graph_removeEdge(this.ptr, e);
        return takeObject(ret);
    }
    /**
    * @param {number} a
    * @returns {Array<any>}
    */
    neighbors(a) {
        var ret = wasm.graph_neighbors(this.ptr, a);
        return takeObject(ret);
    }
    /**
    * @param {number} a
    * @param {number} dir
    * @returns {Array<any>}
    */
    neighborsDirected(a, dir) {
        var ret = wasm.graph_neighborsDirected(this.ptr, a, dir);
        return takeObject(ret);
    }
    /**
    * @param {number} a
    * @returns {Array<any>}
    */
    neighborsUndirected(a) {
        var ret = wasm.graph_neighborsUndirected(this.ptr, a);
        return takeObject(ret);
    }
    /**
    * @param {number} a
    * @returns {Array<any>}
    */
    edges(a) {
        var ret = wasm.graph_edges(this.ptr, a);
        return takeObject(ret);
    }
    /**
    * @param {number} a
    * @param {number} b
    * @returns {boolean}
    */
    containsEdge(a, b) {
        var ret = wasm.graph_containsEdge(this.ptr, a, b);
        return ret !== 0;
    }
    /**
    * @param {number} a
    * @param {number} b
    * @returns {number}
    */
    findEdge(a, b) {
        var ret = wasm.graph_findEdge(this.ptr, a, b);
        return ret >>> 0;
    }
    /**
    * @param {number} dir
    * @returns {Array<any>}
    */
    externals(dir) {
        var ret = wasm.graph_externals(this.ptr, dir);
        return takeObject(ret);
    }
    /**
    * @returns {Array<any>}
    */
    nodeIndices() {
        var ret = wasm.graph_nodeIndices(this.ptr);
        return takeObject(ret);
    }
    /**
    * @returns {Array<any>}
    */
    edgeIndices() {
        var ret = wasm.graph_edgeIndices(this.ptr);
        return takeObject(ret);
    }
}
module.exports.Graph = Graph;
/**
*/
class LinkForce {

    free() {
        const ptr = this.ptr;
        this.ptr = 0;

        wasm.__wbg_linkforce_free(ptr);
    }
    /**
    * @param {Graph} graph
    */
    constructor(graph) {
        _assertClass(graph, Graph);
        var ret = wasm.linkforce_new(graph.ptr);
        return Force.__wrap(ret);
    }
}
module.exports.LinkForce = LinkForce;
/**
*/
class ManyBodyForce {

    free() {
        const ptr = this.ptr;
        this.ptr = 0;

        wasm.__wbg_manybodyforce_free(ptr);
    }
    /**
    * @param {Graph} graph
    */
    constructor(graph) {
        _assertClass(graph, Graph);
        var ret = wasm.manybodyforce_new(graph.ptr);
        return Force.__wrap(ret);
    }
}
module.exports.ManyBodyForce = ManyBodyForce;
/**
*/
class Simulation {

    static __wrap(ptr) {
        const obj = Object.create(Simulation.prototype);
        obj.ptr = ptr;

        return obj;
    }

    free() {
        const ptr = this.ptr;
        this.ptr = 0;

        wasm.__wbg_simulation_free(ptr);
    }
    /**
    * @param {Graph} graph
    * @param {Function} f
    */
    constructor(graph, f) {
        try {
            _assertClass(graph, Graph);
            var ret = wasm.simulation_new(graph.ptr, addBorrowedObject(f));
            return Simulation.__wrap(ret);
        } finally {
            heap[stack_pointer++] = undefined;
        }
    }
    /**
    * @param {any[]} js_forces
    * @returns {any}
    */
    run(js_forces) {
        var ptr0 = passArrayJsValueToWasm0(js_forces, wasm.__wbindgen_malloc);
        var len0 = WASM_VECTOR_LEN;
        var ret = wasm.simulation_run(this.ptr, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @param {number} n
    * @param {any[]} js_forces
    * @returns {any}
    */
    runStep(n, js_forces) {
        var ptr0 = passArrayJsValueToWasm0(js_forces, wasm.__wbindgen_malloc);
        var len0 = WASM_VECTOR_LEN;
        var ret = wasm.simulation_runStep(this.ptr, n, ptr0, len0);
        return takeObject(ret);
    }
    /**
    * @returns {boolean}
    */
    isFinished() {
        var ret = wasm.simulation_isFinished(this.ptr);
        return ret !== 0;
    }
    /**
    * @param {number} alpha_start
    */
    reset(alpha_start) {
        wasm.simulation_reset(this.ptr, alpha_start);
    }
    /**
    * @returns {number}
    */
    get alphaStart() {
        var ret = wasm.simulation_alpha(this.ptr);
        return ret;
    }
    /**
    * @param {number} value
    */
    set alphaStart(value) {
        wasm.simulation_reset(this.ptr, value);
    }
    /**
    * @returns {number}
    */
    get alphaMin() {
        var ret = wasm.simulation_alpha_min(this.ptr);
        return ret;
    }
    /**
    * @param {number} value
    */
    set alphaMin(value) {
        wasm.simulation_set_alpha_min(this.ptr, value);
    }
    /**
    * @returns {number}
    */
    get alphaTarget() {
        var ret = wasm.simulation_alpha_target(this.ptr);
        return ret;
    }
    /**
    * @param {number} value
    */
    set alphaTarget(value) {
        wasm.simulation_set_alpha_target(this.ptr, value);
    }
    /**
    * @returns {number}
    */
    get velocityDecay() {
        var ret = wasm.simulation_velocity_decay(this.ptr);
        return ret;
    }
    /**
    * @param {number} value
    */
    set velocityDecay(value) {
        wasm.simulation_set_velocity_decay(this.ptr, value);
    }
    /**
    * @returns {number}
    */
    get iterations() {
        var ret = wasm.simulation_iterations(this.ptr);
        return ret >>> 0;
    }
    /**
    * @param {number} value
    */
    set iterations(value) {
        wasm.simulation_set_iterations(this.ptr, value);
    }
}
module.exports.Simulation = Simulation;

module.exports.__wbindgen_string_new = function(arg0, arg1) {
    var ret = getStringFromWasm0(arg0, arg1);
    return addHeapObject(ret);
};

module.exports.__wbindgen_number_new = function(arg0) {
    var ret = arg0;
    return addHeapObject(ret);
};

module.exports.__wbindgen_object_drop_ref = function(arg0) {
    takeObject(arg0);
};

module.exports.__wbindgen_json_serialize = function(arg0, arg1) {
    const obj = getObject(arg1);
    var ret = JSON.stringify(obj === undefined ? null : obj);
    var ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
};

module.exports.__wbindgen_object_clone_ref = function(arg0) {
    var ret = getObject(arg0);
    return addHeapObject(ret);
};

module.exports.__wbindgen_json_parse = function(arg0, arg1) {
    var ret = JSON.parse(getStringFromWasm0(arg0, arg1));
    return addHeapObject(ret);
};

module.exports.__wbg_get_a8b9619536c590d4 = function(arg0, arg1) {
    var ret = getObject(arg0)[arg1 >>> 0];
    return addHeapObject(ret);
};

module.exports.__wbg_get_4bab9404e99a1f85 = handleError(function(arg0, arg1) {
    var ret = Reflect.get(getObject(arg0), getObject(arg1));
    return addHeapObject(ret);
});

module.exports.__wbg_new_1abc33d4f9ba3e80 = function() {
    var ret = new Array();
    return addHeapObject(ret);
};

module.exports.__wbg_push_44968dcdf4cfbb43 = function(arg0, arg1) {
    var ret = getObject(arg0).push(getObject(arg1));
    return ret;
};

module.exports.__wbg_call_7a2b5e98ac536644 = handleError(function(arg0, arg1, arg2) {
    var ret = getObject(arg0).call(getObject(arg1), getObject(arg2));
    return addHeapObject(ret);
});

module.exports.__wbg_new_dc5b27cfd2149b8f = function() {
    var ret = new Object();
    return addHeapObject(ret);
};

module.exports.__wbg_set_3afd31f38e771338 = handleError(function(arg0, arg1, arg2) {
    var ret = Reflect.set(getObject(arg0), getObject(arg1), getObject(arg2));
    return ret;
});

module.exports.__wbindgen_number_get = function(arg0, arg1) {
    const obj = getObject(arg1);
    var ret = typeof(obj) === 'number' ? obj : undefined;
    getFloat64Memory0()[arg0 / 8 + 1] = isLikeNone(ret) ? 0 : ret;
    getInt32Memory0()[arg0 / 4 + 0] = !isLikeNone(ret);
};

module.exports.__wbindgen_debug_string = function(arg0, arg1) {
    var ret = debugString(getObject(arg1));
    var ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
};

module.exports.__wbindgen_throw = function(arg0, arg1) {
    throw new Error(getStringFromWasm0(arg0, arg1));
};

module.exports.__wbindgen_rethrow = function(arg0) {
    throw takeObject(arg0);
};

const path = require('path').join(__dirname, 'egraph_wasm_bg.wasm');
const bytes = require('fs').readFileSync(path);

const wasmModule = new WebAssembly.Module(bytes);
const wasmInstance = new WebAssembly.Instance(wasmModule, imports);
wasm = wasmInstance.exports;
module.exports.__wasm = wasm;

