/* tslint:disable */
/* eslint-disable */
/**
* @param {Graph} graph
* @returns {any}
*/
export function initialPlacement(graph: Graph): any;
/**
* @param {Graph} graph
* @returns {Array<any>}
*/
export function forceConnected(graph: Graph): Array<any>;
/**
* @param {Graph} graph
* @returns {Array<any>}
*/
export function forceNonconnected(graph: Graph): Array<any>;
/**
* @param {Graph} graph
* @param {Function} group_accessor
* @returns {Array<any>}
*/
export function forceGrouped(graph: Graph, group_accessor: Function): Array<any>;
/**
* @param {Graph} graph
* @param {any} coordinates
* @param {Function} _length
* @param {number} eps
* @param {number} width
* @param {number} height
* @returns {any}
*/
export function kamadaKawai(graph: Graph, coordinates: any, _length: Function, eps: number, width: number, height: number): any;
/**
* @param {Graph} graph
* @param {number} min_size
* @param {number} step_iteration
* @param {Function} _shrink_node
* @param {Function} _shrink_edge
* @param {Function} _link_distance_accessor
* @returns {any}
*/
export function fm3(graph: Graph, min_size: number, step_iteration: number, _shrink_node: Function, _shrink_edge: Function, _link_distance_accessor: Function): any;
/**
* @param {Graph} graph
* @param {any} coordinates
* @returns {any}
*/
export function fdeb(graph: Graph, coordinates: any): any;
/**
*/
export class CenterForce {
  free(): void;
/**
*/
  constructor();
}
/**
*/
export class Force {
  free(): void;
}
/**
*/
export class Graph {
  free(): void;
/**
*/
  constructor();
/**
* @returns {number}
*/
  nodeCount(): number;
/**
* @returns {number}
*/
  edgeCount(): number;
/**
* @param {any} value
* @returns {number}
*/
  addNode(value: any): number;
/**
* @param {number} a
* @returns {any}
*/
  nodeWeight(a: number): any;
/**
* @param {number} a
* @param {number} b
* @param {any} value
* @returns {number}
*/
  addEdge(a: number, b: number, value: any): number;
/**
* @param {number} e
* @returns {any}
*/
  edgeWeight(e: number): any;
/**
* @param {number} e
* @returns {Array<any>}
*/
  edgeEndpoints(e: number): Array<any>;
/**
* @param {number} a
* @returns {any}
*/
  removeNode(a: number): any;
/**
* @param {number} e
* @returns {any}
*/
  removeEdge(e: number): any;
/**
* @param {number} a
* @returns {Array<any>}
*/
  neighbors(a: number): Array<any>;
/**
* @param {number} a
* @param {number} dir
* @returns {Array<any>}
*/
  neighborsDirected(a: number, dir: number): Array<any>;
/**
* @param {number} a
* @returns {Array<any>}
*/
  neighborsUndirected(a: number): Array<any>;
/**
* @param {number} a
* @returns {Array<any>}
*/
  edges(a: number): Array<any>;
/**
* @param {number} a
* @param {number} b
* @returns {boolean}
*/
  containsEdge(a: number, b: number): boolean;
/**
* @param {number} a
* @param {number} b
* @returns {number}
*/
  findEdge(a: number, b: number): number;
/**
* @param {number} dir
* @returns {Array<any>}
*/
  externals(dir: number): Array<any>;
/**
* @returns {Array<any>}
*/
  nodeIndices(): Array<any>;
/**
* @returns {Array<any>}
*/
  edgeIndices(): Array<any>;
}
/**
*/
export class LinkForce {
  free(): void;
/**
* @param {Graph} graph
*/
  constructor(graph: Graph);
}
/**
*/
export class ManyBodyForce {
  free(): void;
/**
* @param {Graph} graph
*/
  constructor(graph: Graph);
}
/**
*/
export class Simulation {
  free(): void;
/**
* @param {Graph} graph
* @param {Function} f
*/
  constructor(graph: Graph, f: Function);
/**
* @param {any[]} js_forces
* @returns {any}
*/
  run(js_forces: any[]): any;
/**
* @param {number} n
* @param {any[]} js_forces
* @returns {any}
*/
  runStep(n: number, js_forces: any[]): any;
/**
* @returns {boolean}
*/
  isFinished(): boolean;
/**
* @param {number} alpha_start
*/
  reset(alpha_start: number): void;
/**
* @returns {number}
*/
  alphaMin: number;
/**
* @returns {number}
*/
  alphaStart: number;
/**
* @returns {number}
*/
  alphaTarget: number;
/**
* @returns {number}
*/
  iterations: number;
/**
* @returns {number}
*/
  velocityDecay: number;
}

export type InitInput = RequestInfo | URL | Response | BufferSource | WebAssembly.Module;

export interface InitOutput {
  readonly memory: WebAssembly.Memory;
  readonly initialPlacement: (a: number) => number;
  readonly forceConnected: (a: number) => number;
  readonly forceNonconnected: (a: number) => number;
  readonly __wbg_force_free: (a: number) => void;
  readonly __wbg_centerforce_free: (a: number) => void;
  readonly centerforce_new: () => number;
  readonly linkforce_new: (a: number) => number;
  readonly manybodyforce_new: (a: number) => number;
  readonly forceGrouped: (a: number, b: number) => number;
  readonly __wbg_linkforce_free: (a: number) => void;
  readonly __wbg_manybodyforce_free: (a: number) => void;
  readonly __wbg_simulation_free: (a: number) => void;
  readonly simulation_new: (a: number, b: number) => number;
  readonly simulation_run: (a: number, b: number, c: number) => number;
  readonly simulation_runStep: (a: number, b: number, c: number, d: number) => number;
  readonly simulation_isFinished: (a: number) => number;
  readonly simulation_reset: (a: number, b: number) => void;
  readonly simulation_alpha: (a: number) => number;
  readonly simulation_alpha_min: (a: number) => number;
  readonly simulation_set_alpha_min: (a: number, b: number) => void;
  readonly simulation_alpha_target: (a: number) => number;
  readonly simulation_set_alpha_target: (a: number, b: number) => void;
  readonly simulation_velocity_decay: (a: number) => number;
  readonly simulation_set_velocity_decay: (a: number, b: number) => void;
  readonly simulation_iterations: (a: number) => number;
  readonly simulation_set_iterations: (a: number, b: number) => void;
  readonly simulation_set_alpha: (a: number, b: number) => void;
  readonly kamadaKawai: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly __wbg_graph_free: (a: number) => void;
  readonly graph_new: () => number;
  readonly graph_nodeCount: (a: number) => number;
  readonly graph_edgeCount: (a: number) => number;
  readonly graph_addNode: (a: number, b: number) => number;
  readonly graph_nodeWeight: (a: number, b: number) => number;
  readonly graph_addEdge: (a: number, b: number, c: number, d: number) => number;
  readonly graph_edgeWeight: (a: number, b: number) => number;
  readonly graph_edgeEndpoints: (a: number, b: number) => number;
  readonly graph_removeNode: (a: number, b: number) => number;
  readonly graph_removeEdge: (a: number, b: number) => number;
  readonly graph_neighbors: (a: number, b: number) => number;
  readonly graph_neighborsDirected: (a: number, b: number, c: number) => number;
  readonly graph_neighborsUndirected: (a: number, b: number) => number;
  readonly graph_edges: (a: number, b: number) => number;
  readonly graph_containsEdge: (a: number, b: number, c: number) => number;
  readonly graph_findEdge: (a: number, b: number, c: number) => number;
  readonly graph_externals: (a: number, b: number) => number;
  readonly graph_nodeIndices: (a: number) => number;
  readonly graph_edgeIndices: (a: number) => number;
  readonly fm3: (a: number, b: number, c: number, d: number, e: number, f: number) => number;
  readonly fdeb: (a: number, b: number) => number;
  readonly __wbindgen_malloc: (a: number) => number;
  readonly __wbindgen_realloc: (a: number, b: number, c: number) => number;
  readonly __wbindgen_exn_store: (a: number) => void;
}

/**
* If `module_or_path` is {RequestInfo} or {URL}, makes a request and
* for everything else, calls `WebAssembly.instantiate` directly.
*
* @param {InitInput | Promise<InitInput>} module_or_path
*
* @returns {Promise<InitOutput>}
*/
export default function init (module_or_path?: InitInput | Promise<InitInput>): Promise<InitOutput>;
        